<?php
 
//-----------------------------------------------------------------------------------------
// PHP Image Gallery 2.0
// preparing the various parts of the gallery
//-----------------------------------------------------------------------------------------

// getting present gal from titlebar
header("Content-type: text/html; charset=utf-8");
if($_GET) { extract($_GET, EXTR_PREFIX_SAME, "get_"); }
if (!isset($gal)) { $gal = 1; } 

// getting gif and jpg images from the current dir
$dir= "gallery".$gal;
@$d = dir($dir);
if ($d) { 
	while($entry=$d->read()) {  
		$entry = preg_replace("/ /","%20",$entry);
		$posa = strpos (strtolower($entry), ".jpg");
		$posb = strpos (strtolower($entry), ".gif");
		if (!($posa === false) || !($posb === false)) {  
			$pics[] = $dir."/".$entry; 
		} 
	}
	$d->close();
	sort($pics);
}

// getting the links from links.txt
$n = 1;
$links = array();
$fp = fopen("links.txt", "r");
while (!feof($fp)) {
	$link = fgets($fp, 500);
	if($link) {
		$links[$n] = rtrim($link);
		$n++; 
	} 
}
fclose($fp);

// getting the comments from galleryXX.txt
$n = 0;
$comments = array();
$cmt = $dir.".txt";
if (file_exists($cmt)) {  
	$fp = fopen($cmt, "r");
	while (!feof($fp)) {
		$text = fgets($fp, 5000);
		if ($text) {
			$comments[$n] = rtrim($text);
			$n++; 
		}
	}
	fclose($fp); 
} else {
	for($i=0; $i<sizeof($pics); $i++) {
		$comments[$i] = "&nbsp;";
	}
}


//-----------------------------------------------------------------------------------------
// displaying the html page
//-----------------------------------------------------------------------------------------
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">


<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>PHP Photo Gallery</title>

<!-- Stye Sheet -->
<style type="text/css">
  body { background-color: #eeeeee; font:10px/16px verdana; color: black; text-align:center; } 
  a { color: black; }
  a:hover { color: #cc0000; }
  div { margin:20px; }
  #pic { border:1px solid black; }
  #pic:hover { border:1px solid #cc0000; }
</style>


<!-- Javascript for gallery navigation -->
<script type="text/javascript">

var curr = <? if($pic) { echo $pic; } else { echo "0"; } ?>;	

var pics = new Array(<?
// php loop for printing all the pics into javascript
for ($i=0; $i<sizeof($pics); $i++) {
	echo "\"$pics[$i]\"";
	if ($i != sizeof($pics)-1) { echo ","; }
}  ?>)

var comments = new Array(<?
// function to slash strange characters for javascript
function addjsslashes($str) { return addcslashes($str, "\0..\37!@\@\177..\377\'\""); }
// php loop for printing all the comments into javascript
for ($i=0; $i<sizeof($comments); $i++) {
	echo "\"".addjsslashes($comments[$i])."\"";
	if ($i != sizeof($comments)-1) { echo ","; }
} ?>)

function nextPic() {
	if (curr == pics.length - 1) {	curr = 0; } else { curr++; }
	showPic(curr);	
};

function prevPic() {
	if (curr == 0) { curr = pics.length-1; } else { curr--; }
	showPic(curr);	
};

function skipPrev() {
	if (curr < 10) { curr = 0; } else { curr-=10; }
	showPic(curr);	
};

function skipNext() {
	if (curr > pics.length-11) { curr = pics.length-1; } else { curr+=10; }
	showPic(curr);	
};

function showPic (curr) {
	document.getElementById('cnt').childNodes[0].nodeValue = (curr+1)+"-"+pics.length;
	document.getElementById('pic').src = pics[curr];
	document.getElementById('pic').alt = comments[curr];
	document.getElementById('desc').childNodes[0].nodeValue = comments[curr];
	return false;
};
</script>


</head>
<body>


<!-- layer with the links -->
<div id="links"><?
// phploop for printing all the links
for ($i=1; $i<=sizeof($links); $i++) {
	echo "<a href=\"?gal=".$i."\">".$links[$i]."</a>";
	if ( $i<sizeof($links)) { echo " | "; }
}
?>
</div>


<!-- layer with the image -->
<div id="picture">
<a onclick="nextPic();" href="#"><img id="pic" src="<? if($pic) { echo $pics[$pic]; } else { echo $pics[0]; } ?>" alt="<?=$comments[0]?>" /></a>
</div>


<!-- layer with the comments -->
<div id="desc"><?=$comments[0]?></div>


<!-- layer with the navigation -->
<div id="nav">
	<? if(sizeof($pics) > 12) { ?><a onclick="skipPrev()" href="#">Skip 10</a> | <? } ?> 
	<a onclick="prevPic()" href="#">Prev</a>
	| <span id="cnt">1 of <?=sizeof($pics)?></span> |
	<a onclick="nextPic()" href="#">Next</a> 
	<? if(sizeof($pics) > 12) { ?><a onclick="skipNext()" href="#">Skip 10</a><? } ?>
</div>


</body>
</html>